# -*- coding: utf-8 -*-
"""web module"""

import logging

from dwho.classes.modules import DWhoModuleWebBase, MODULES
from dwho.classes.plugins import PLUGINS

LOG = logging.getLogger('fd-vpn.modules.web')


class WebModule(DWhoModuleWebBase):
    MODULE_NAME = 'fd_vpn.web'

    def safe_init(self, options):
        self.plugin_credentials = PLUGINS['credentials']

    def html(self, request):
        cmd = request.get_cmd()
        options = request.query_params()
        if 'path' not in options or not cmd.root:
            return self._anonymous

        self.plugin_credentials.set_request(request)
        path = cmd.root + options['path'].replace('..', '')

        return self.frender(path,
                            CONFIG   = self.config,
                            has_role = self.plugin_credentials.has_role,
                            roles    = self.plugin_credentials.get_roles(),
                            is_admin = self.plugin_credentials.is_admin())

    def index(self, request):
        self.plugin_credentials.set_request(request)

        return self.render('index.html',
                           CONFIG   = self.config,
                           has_role = self.plugin_credentials.has_role,
                           roles    = self.plugin_credentials.get_roles(),
                           is_admin = self.plugin_credentials.is_admin())


if __name__ != "__main__":
    def _start():
        MODULES.register(WebModule())
    _start()
