# -*- coding: utf-8 -*-
"""vpn_user object"""

import logging

from dwho.classes.objects import DWhoObjectSQLBase

LOG = logging.getLogger('fd-vpn.objects.vpn_user')


class FdVpnObjectVPNUser(DWhoObjectSQLBase):
    CONNECTION_NAME = 'db'
    TABLE_NAME      = 'vpn_user'
    COLUMNS         = ('id',
                       'username',
                       'enabled',
                       'created_at',
                       'updated_at')

    def __init__(self):
        from fd_vpn.objects.vpn_server import FdVpnObjectVPNServer

        self.obj_server = FdVpnObjectVPNServer

        DWhoObjectSQLBase.__init__(self)

    def get_servers(self, to_dict = False, **conditions):
        db              = self.connect()

        table_server    = self.obj_server.TABLE_NAME
        columns         = self.get_columns() + self.obj_server.get_columns()

        query           = ("SELECT ${columns} " +
                           "FROM " + self.TABLE_NAME + " "
                           "INNER JOIN " + table_server + " "
                             "ON " + self.TABLE_NAME + ".id = " + table_server + ".user_id")

        cond_values     = None

        if conditions:
            cond            = self._prepare_condition(conditions)
            query          += " WHERE " + cond[0]
            cond_values     = cond[1]

        db['cursor'].query(query,
                           columns,
                           cond_values)
        res         = db['cursor'].fetchall()

        if not res:
            return False

        if not to_dict:
            return res

        r           = []

        for row in res:
            xobject = {}

            for column in columns:
                xobject[column] = self.db_prepare_column(row[column], column)

            r.append(xobject)

        return r
