#SetCompressor /FINAL /SOLID lzma

!define FD_VPN_ORGANIZATION_NAME "Fjord Technologies"
!define FD_VPN_APPLICATION_MAINTAINER "Fjord Technologies"
!define FD_VPN_APPLICATION_DESCRIPTION "vpn.supercmd.io Installer"
!define FD_VPN_APPLICATION_MAINTAINER_EMAIL "prod@commandersact.com"
!define FD_VPN_APPLICATION_COPYRIGHT "Copyright 2022 Fjord Technologies"
!define FD_VPN_APPLICATION_DISPLAY_NAME "vpn.supercmd.io"
!define FD_VPN_APPLICATION_NAME "vpn.supercmd.io"
!define FD_VPN_APPLICATION_VIVERSION "0.1.0.0"
!define FD_VPN_APPLICATION_VERSION "0.1"

!define MULTIUSER_EXECUTIONLEVEL Highest
!define MULTIUSER_MUI
#!define MUI_ICON "${FD_VPN_APPLICATION_NAME}.ico"

!define /date CURRENT_DATETIME "%Y%m%d%H%M%S"
!define INSTALL_FILENAME_CURRENT "${FD_VPN_APPLICATION_NAME}.exe"
!define REG_UNINST "Software\Microsoft\Windows\CurrentVersion\Uninstall\${FD_VPN_APPLICATION_NAME}"

!include MultiUser.nsh
!include MUI2.nsh

Name "${FD_VPN_APPLICATION_DISPLAY_NAME} ${FD_VPN_APPLICATION_VERSION}"
OutFile "${INSTALL_FILENAME_CURRENT}"

InstallDir "$PROGRAMFILES\${FD_VPN_APPLICATION_NAME}"
InstallDirRegKey HKLM "Software\${FD_VPN_ORGANIZATION_NAME}\${FD_VPN_APPLICATION_NAME}" "Install_Dir"

RequestExecutionLevel admin
ShowInstDetails show
ShowUninstDetails show

!define MUI_LANGDLL_ALLLANGUAGES

!insertmacro MULTIUSER_PAGE_INSTALLMODE

#!insertmacro MUI_PAGE_DIRECTORY

Page custom additionalTasksPageEnter additionalTasksPageLeave

Var additional_tasks_dialog
Var additional_tasks_label_additional_icons
Var additional_tasks_checkbox_shortcut_desktop
Var additional_tasks_checkbox_shortcut_startmenu
Var additional_tasks_checkbox_shortcut_desktop_state
Var additional_tasks_checkbox_shortcut_startmenu_state

Function additionalTasksPageEnter
    !insertmacro MUI_HEADER_TEXT "Slectionnez les tches supplmentaires" "Quelles sont les tches supplmentaires qui doivent tre effectues ?"

    nsDialogs::Create 1018
    Pop $additional_tasks_dialog

    ${If} $additional_tasks_dialog == error
        Abort
    ${EndIf}

    ${NSD_CreateLabel} 0 0 100% 10u "Icnes supplmentaires :"
    Pop $additional_tasks_label_additional_icons

    ${NSD_CreateCheckbox} 0 10u 100% 10u "Crer une icne sur le &Bureau"
    Pop $additional_tasks_checkbox_shortcut_desktop

    ${NSD_CreateCheckbox} 0 20u 100% 10u "Crer les icnes dans le &Menu Dmarrer"
    Pop $additional_tasks_checkbox_shortcut_startmenu

    ${NSD_Check} $additional_tasks_checkbox_shortcut_desktop
    ${NSD_Check} $additional_tasks_checkbox_shortcut_startmenu

    nsDialogs::Show
FunctionEnd

Function additionalTasksPageLeave
    ${NSD_GetState} $additional_tasks_checkbox_shortcut_desktop $additional_tasks_checkbox_shortcut_desktop_state
    ${NSD_GetState} $additional_tasks_checkbox_shortcut_startmenu $additional_tasks_checkbox_shortcut_startmenu_state
FunctionEnd

!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

Section "installFiles" installFiles
    SetOutPath $INSTDIR
    #File ${FD_VPN_APPLICATION_NAME}.ico
    File /r ${FD_VPN_BUILD_DIR}\*

    #ExecDos::exec /DETAILED "$INSTDIR\openvpn-installer.exe /SELECT_SHORTCUTS=0 /SELECT_OPENVPN=1 /SELECT_SERVICE=1 /SELECT_TAP=1 /SELECT_OPENVPNGUI=0 /SELECT_ASSOCIATIONS=1 /SELECT_OPENSSL_UTILITIES=0 /SELECT_EASYRSA=0 /SELECT_PATH=1 /SELECT_OPENSSLDLLS=1 /SELECT_LZODLLS=1 /SELECT_PKCS11DLLS=1 /S /D=$INSTDIR\OpenVPN"
    #ExecDos::exec /DETAILED "$INSTDIR\openvpn-installer.exe"
    ExecWait '"$INSTDIR\openvpn-installer.exe" /SELECT_SHORTCUTS=0 /SELECT_OPENVPN=1 /SELECT_SERVICE=1 /SELECT_TAP=1 /SELECT_OPENVPNGUI=0 /SELECT_ASSOCIATIONS=1 /SELECT_OPENSSL_UTILITIES=0 /SELECT_EASYRSA=0 /SELECT_PATH=1 /SELECT_OPENSSLDLLS=1 /SELECT_LZODLLS=1 /SELECT_PKCS11DLLS=1 /S /D=$INSTDIR\OpenVPN'

    SimpleFC::AdvRemoveRule "FD_VPN"
    SimpleFC::AdvAddRule "FD_VPN-${FD_VPN_SERVER_REFERENCE}" "FD_VPN" 256 1 1 2147483647 1 "" "" "" "" "" "" "${FD_VPN_CIDR}" "" ""

    # Write keys in Registry in order for the applications to appear in Add/Remove Programs
    WriteRegStr HKLM "Software\${FD_VPN_ORGANIZATION_NAME}\${FD_VPN_APPLICATION_NAME}" "Install_Dir" "$INSTDIR"
    WriteRegStr HKLM ${REG_UNINST} "DisplayName" "${FD_VPN_APPLICATION_DISPLAY_NAME}"
    WriteRegStr HKLM ${REG_UNINST} "Publisher" "${FD_VPN_ORGANIZATION_NAME}"
    #WriteRegStr HKLM ${REG_UNINST} "DisplayIcon" "$INSTDIR\${FD_VPN_APPLICATION_NAME}.ico"
    WriteRegStr HKLM ${REG_UNINST} "UninstallString" '"$INSTDIR\uninstall.exe"'
    WriteRegDWORD HKLM ${REG_UNINST} "NoModify" 1
    WriteRegDWORD HKLM ${REG_UNINST} "NoRepair" 1
    WriteUninstaller "$INSTDIR\uninstall.exe"

    !define FD_VPN_APPLICATION_EXECUTABLE "$INSTDIR\OpenVPN\config\${FD_VPN_CLIENT_REFERENCE}.bat"

    FileOpen $9 "${FD_VPN_APPLICATION_EXECUTABLE}" w
    FileWrite $9 '@echo off$\r$\n'
    FileWrite $9 'cd "$INSTDIR\OpenVPN\config"$\r$\n'
    FileWrite $9 '$\r$\n'
    FileWrite $9 ':: BatchGotAdmin$\r$\n'
    FileWrite $9 ':-------------------------------------$\r$\n'
    FileWrite $9 '$\r$\n'
    FileWrite $9 'REM  --> Check for permissions$\r$\n'
    FileWrite $9 '    IF "%PROCESSOR_ARCHITECTURE%" EQU "amd64" ($\r$\n'
    FileWrite $9 '>nul 2>&1 "%SYSTEMROOT%\SysWOW64\cacls.exe" "%SYSTEMROOT%\SysWOW64\config\system"$\r$\n'
    FileWrite $9 ') ELSE ($\r$\n'
    FileWrite $9 '>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"$\r$\n'
    FileWrite $9 ')$\r$\n'
    FileWrite $9 '$\r$\n'
    FileWrite $9 'REM --> If error flag set, we do not have admin.$\r$\n'
    FileWrite $9 "if '%errorlevel%' NEQ '0' ($\r$\n"
    FileWrite $9 '    echo Requesting administrative privileges...$\r$\n'
    FileWrite $9 '    goto UACPrompt$\r$\n'
    FileWrite $9 ') else ( goto gotAdmin )$\r$\n'
    FileWrite $9 '$\r$\n'
    FileWrite $9 ':UACPrompt$\r$\n'
    FileWrite $9 '    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"$\r$\n'
    FileWrite $9 '    set params = %*:"=""$\r$\n'
    FileWrite $9 '    echo UAC.ShellExecute "cmd.exe", "/c ""%~s0"" %params%", "", "runas", 2 >> "%temp%\getadmin.vbs"$\r$\n'
    FileWrite $9 '$\r$\n'
    FileWrite $9 '    "%temp%\getadmin.vbs"$\r$\n'
    FileWrite $9 '    del "%temp%\getadmin.vbs"$\r$\n'
    FileWrite $9 '    exit /B$\r$\n'
    FileWrite $9 '$\r$\n'
    FileWrite $9 ':gotAdmin$\r$\n'
    FileWrite $9 '    pushd "%CD%"$\r$\n'
    FileWrite $9 '    CD /D "%~dp0"$\r$\n'
    FileWrite $9 ':--------------------------------------$\r$\n'
    FileWrite $9 '    ..\bin\openvpn.exe --config ${FD_VPN_CLIENT_REFERENCE}.conf$\r$\n'
    FileWrite $9 '    exit$\r$\n'
    FileClose $9

    ${If} $additional_tasks_checkbox_shortcut_desktop_state == ${BST_CHECKED}
    ${OrIf} ${Silent}
        CreateShortCut "$DESKTOP\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk" "${FD_VPN_APPLICATION_EXECUTABLE}"
    ${EndIf}

    ${If} $additional_tasks_checkbox_shortcut_startmenu_state == ${BST_CHECKED}
    ${OrIf} ${Silent}
        CreateShortCut "$SMPROGRAMS\Startup\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk" "${FD_VPN_APPLICATION_EXECUTABLE}" "" ""

        CreateDirectory "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}"
        #CreateShortCut "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk" "${FD_VPN_APPLICATION_EXECUTABLE}" "" "$INSTDIR\${FD_VPN_APPLICATION_NAME}.ico"
        CreateShortCut "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk" "${FD_VPN_APPLICATION_EXECUTABLE}" "" ""
        CreateShortCut "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}\Uninstall ${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk" "$INSTDIR\uninstall.exe"
    ${EndIf}
SectionEnd

#!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH

# Uninstall
Section "Uninstall"
    SimpleFC::AdvRemoveRule "FD_VPN-${FD_VPN_SERVER_REFERENCE}"
    Delete "$INSTDIR\uninstall.exe"
    ExecWait "$INSTDIR\OpenVPN\Uninstall.exe \S"
    Delete "$DESKTOP\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk"
    Delete "$SMPROGRAMS\Startup\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk"
    Delete "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}\${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk"
    Delete "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}\Uninstall ${FD_VPN_APPLICATION_DISPLAY_NAME}.lnk"
    RmDir "$SMPROGRAMS\${FD_VPN_ORGANIZATION_NAME}"
    RmDir /r "$INSTDIR"
    #RmDir "$INSTDIR\..\..\${FD_VPN_ORGANIZATION_NAME}"
    DeleteRegKey HKLM ${REG_UNINST}
    DeleteRegKey HKLM "Software\${FD_VPN_ORGANIZATION_NAME}\${FD_VPN_APPLICATION_NAME}"
    DeleteRegKey /ifempty HKLM "Software\${FD_VPN_APPLICATION_NAME}"
SectionEnd

!insertmacro MUI_LANGUAGE "French"

Function .onInit
    !insertmacro MULTIUSER_INIT
FunctionEnd

#Function .onInstSuccess
#    MessageBox MB_YESNO "Lancer ${FD_VPN_APPLICATION_DISPLAY_NAME} ${FD_VPN_APPLICATION_VERSION} maintenant" IDYES true IDNO false
#    true:
#        Exec "${FD_VPN_APPLICATION_EXECUTABLE}"
#    false:
#        SetAutoClose true
#FunctionEnd

Function un.onInit
  !insertMacro MULTIUSER_UNINIT
FunctionEnd

VIProductVersion "${FD_VPN_APPLICATION_VIVERSION}"
VIAddVersionKey "CompanyName" "${FD_VPN_ORGANIZATION_NAME}"
VIAddVersionKey "FileDescription" "${FD_VPN_APPLICATION_DISPLAY_NAME}"
VIAddVersionKey "FileVersion" "${FD_VPN_APPLICATION_VERSION}.${CURRENT_DATETIME}"
VIAddVersionKey "LegalCopyright" "${FD_VPN_APPLICATION_COPYRIGHT}"
VIAddVersionKey "OriginalFilename" "${INSTALL_FILENAME_CURRENT}"
VIAddVersionKey "ProductName" "${FD_VPN_APPLICATION_DISPLAY_NAME}"
VIAddVersionKey "ProductVersion" "${FD_VPN_APPLICATION_VERSION}"
