var fd_refresh_routes = {'vpn_client/index': 10000};

var fd_del_vars = {'vpn_user':      ['enabled',
                                     'created_at',
                                     'updated_at'],
                   'vpn_server':    ['reference',
                                     'cidr',
                                     'port_number',
                                     'username',
                                     'enabled',
                                     'clients',
                                     'created_at',
                                     'updated_at'],
                   'vpn_client':    ['reference',
                                     'auth_qrcode',
                                     'enabled',
                                     'connected',
                                     'connected_at',
                                     'disconnected_at',
                                     'created_at',
                                     'updated_at']};

var fd_app      = angular.module('fjord',
                                 ['ngResource',
                                  'ngRoute',
                                  'smart-table',
                                  'ui.bootstrap',
                                  'ui.bootstrap.datetimepicker',
                                  'ngTagsInput',
                                  'fdFilters',
                                  'truncate',
                                  'angularFileUpload',
                                  'dndLists',
                                  'ui.select',
                                  'ngSanitize',
                                  'sprintf',
                                  'angular-uuid',
                                  'ngclipboard',
                                  'ui.toggle',
                                  'ngPasswordGenerator']);


if (moment != undefined)
  moment.locale('fr');

(function ()
 {
  fd_app.value('fdRoute',
               {'module': '',
                'action': '',
                'id':     ''});

  angular.module('fdFilters', []).filter('has_len',
    function()
    {
      return function(input, def, retval, allow_bool)
      {
        def         = typeof(def) === 'undefined' ? false : def;
        retval      = typeof(retval) === 'undefined' ? false : retval;
        allow_bool  = (typeof(allow_bool) === 'undefined' || Boolean(allow_bool) === true);

        if (allow_bool === true && input === false)
          input = '0';

        var r       = '';

        switch (typeof(input))
        {
          case 'boolean':
            r = input === true ? '1' : '';
            break;
          case 'number':
            r = String(input);
            break;
          case 'string':
            r = input;
            break;
          default:
            return def;
        }

        if (r.length === 0)
          return def;

        return (Boolean(retval) === false ? true : r);
      }
    }).filter('qrcode',
      function ()
      {
        return function(input)
        {
          return new QRious({'value': input});
        }
      }).filter('moment_duration',
      function ()
      {
        return function(input, xtype)
        {
            return moment.duration(input, xtype).humanize();
        }
      }).filter('math_unit',
      function ()
      {
        return function(input, unit, to_unit)
        {
            r = math.unit(input, unit);
            if (to_unit !== undefined)
                return math.to(r, to_unit);
            else
                return r;
        }
      }).filter('math_to',
      function ()
      {
        return function(input, unit)
        {
            return math.to(input, unit);
        }
      }).filter('math_format',
      function ()
      {
        return function(input, notation, precision)
        {
            option = {};
            if (notation !== undefined)
                option['notation'] = notation;
            if (precision !== undefined)
                option['precision'] = precision;
            return math.format(input, option);
        }
      });

  fd_app.directive('fdValidate',
    function ($q, $http, $routeParams)
    {
      return {
        require: 'ngModel',
        link: function (scope, elm, attrs, ctrl)
              {
                var module_name    = $routeParams.module;
                var param_name     = attrs.fdValidate;
                var parent_grp     = elm.parent();
                var form_feedback  = parent_grp.find('.form-control-feedback');

                ctrl.
                $asyncValidators.
                fdValidate = function (model_value, view_value)
                {
                  if (typeof(ctrl.$validators.fdPreValidate) !== 'undefined')
                  {
                    pre_ret     = ctrl.$validators.fdPreValidate(model_value, view_value);
                    model_value = pre_ret[0];
                    view_value  = pre_ret[1];
                  }

                  if (ctrl.$isEmpty(model_value))
                  {
                    parent_grp.removeClass('has-success');
                    form_feedback.removeClass('glyphicon-ok');

                    if (elm.required === true)
                    {
                      parent_grp.addClass('has-error');
                      form_feedback.addClass('glyphicon-remove');
                    }

                    return $q.when();
                  }

                  var def            = $q.defer();
                  var params         = {};
                  params[param_name] = model_value;

                  $http.get('api/' + module_name + '/validate',
                            {'params': params})
                       .success(function (data)
                                {
                                  parent_grp.removeClass('has-error')
                                            .addClass('has-success');
                                  form_feedback.removeClass('glyphicon-remove')
                                               .addClass('glyphicon-ok');
                                  def.resolve();
                                })
                       .error(function (data)
                              {
                                  parent_grp.removeClass('has-error')
                                  parent_grp.removeClass('has-success')
                                            .addClass('has-error');
                                  form_feedback.removeClass('glyphicon-ok')
                                               .addClass('glyphicon-remove');
                                  def.reject();
                              });

                  return def.promise;
                };
              }
      };
    })

  function fdBtnStatusClass(xstatus)
  {
    switch (xstatus)
    {
      case 'pending':
      case 'processing':
        return 'btn-info';
      case 'failure':
      case 'DELETED':
        return 'btn-danger';
      case 0:
      case '0':
      case 'OFF':
      case 'refused':
        return 'btn-warning';
      case 1:
      case '1':
      case 'ON':
      case 'won':
      case 'success':
      default:
        return 'btn-success';
    }
  }

  function fdIconStatusClass(xstatus)
  {
    switch (xstatus)
    {
      case 'pending':
      case 'processing':
        return 'glyphicon-time';
      case 'won':
        return 'glyphicon-star';
      case 'failure':
      case 'DELETED':
        return 'glyphicon-minus-sign';
      case 0:
      case '0':
      case 'OFF':
      case 'refused':
        return 'glyphicon-warning-sign';
      case 1:
      case '1':
      case 'ON':
      case 'success':
      default:
        return 'glyphicon-ok-sign';
    }
  }

  function fdActionStatusClass(action, xstatus)
  {
    switch (action.concat('-', xstatus))
    {
      case 'disable-OFF':
      case 'enable-ON':
      case 'delete-DELETED':
      case 'won-won':
      case 'pending-pending':
      case 'refused-refused':
        return 'disabled';
      default:
        return '';
    }
  }

  function fdVpnClientLoadLastOctets($scope, $injector, server_id, client_id)
  {
    $scope.last_octets      = null;

    if (!server_id)
        return;

    var $http               = $injector.get('$http');

    $http.get('/api/vpn_client/free-last-octets/' + server_id + '/' + client_id)
         .success(
           function (data)
           {
             $scope.last_octets = data;
           })
         .error(
           function (data, xstatus)
           {
             $scope.notify_code    = data.code || xstatus;
             $scope.notify_message = data.message || 'Unknown Error';
             angular.element('#fd-notify-error').removeClass('hide');
           });
  }

  function fdVpnUserLoadServers($scope, $injector, id)
  {
    $scope.data.servers = null;

    var $http = $injector.get('$http');

    return $http.get('/api/vpn_user/servers/' + id)
         .success(
           function (data)
           {
             $scope.data.servers = data;
           })
         .error(
           function (data, xstatus)
           {
             $scope.notify_code    = data.code || xstatus;
             $scope.notify_message = data.message || 'Unknown Error';
             angular.element('#fd-notify-error').removeClass('hide');
           });
  }

  function fdSyncStatusClass(synced_at, current_date, seconds)
  {
    if (seconds === undefined)
      seconds = 600;

    if (Math.abs(new Date(current_date) - new Date(synced_at)) / 1000 > seconds)
      return 'label-danger';

    return 'label-success';
  }

  function fdDateBeforeRender($view, $dates, $leftDate, $upDate, $rightDate)
  {
    const todaySinceMidnight = new Date();
    todaySinceMidnight.setUTCHours(0,0,0,0);
    $dates.filter(function (date) {
      return date.utcDateValue < todaySinceMidnight.getTime();
    }).forEach(function (date) {
      date.selectable = false;
    });
  }

  function fdApiResource()
  {
    var me         = this;

    this.st_table  = function ($scope, $injector, $timeout)
                     {
                       var ctrl                     = this;
                       this.displayed               = [];
                       var table_state              = {};

                       $scope.obj_ids               = {};
                       $scope.fdBtnStatusClass      = fdBtnStatusClass;
                       $scope.fdIconStatusClass     = fdIconStatusClass;
                       $scope.fdActionStatusClass   = fdActionStatusClass;
                       $scope.fdSyncStatusClass    = fdSyncStatusClass;

                       $scope.downloader            = function (data)
                                                      {
                                                        fd_api_resource.download($scope, $injector, '', data);
                                                      }

                       $scope.stItemsOffset         = 0;
                       $scope.stItemsLimit          = 20;

                       $scope.stfilter              = {};

                       $scope.is_admin              = false;

                       $scope.show                  = function (id)
                                                      {
                                                        me.show($scope, $injector, id);
                                                      }

                       $scope.export                = function (reference, ids)
                                                      {
                                                        var data = {'reference': reference,
                                                                    'ids': []}

                                                        for (var xid in ids)
                                                          data['ids'].push(xid);

                                                        me.download($scope, $injector, '-export', data);
                                                      }

                       $scope.checkAllIds   = function ()
                       {
                         angular.forEach(ctrl.displayed,
                                         function (obj)
                                         {
                                           $scope.obj_ids[obj['customer.id']] = !$scope.obj_ids[obj['customer.id']];
                                         });
                       }

                       this.setStatus = function setStatus(module, action, row, key_id, key_status)
                       {
                         var fdRoute    = $injector.get('fdRoute');
                         fdRoute.module = module;
                         fdRoute.action = action;
                         fdRoute.id     = row[key_id];

                         me._update_status($scope, $injector, key_id, key_status).then(
                          function (data)
                          {
                            var idx = ctrl.displayed.indexOf(row);
                            if (idx !== -1)
                              ctrl.displayed[idx][key_status] = data['status'];
                            ctrl.callServer(ctrl.table_state);
                          });
                       }

                       this.callServer = function callServer(table_state)
                       {
                         ctrl.table_state = table_state;
                         var is_refresh   = false;
                         var fdRoute      = $injector.get('fdRoute');
                         var pagination   = table_state.pagination;
                         var options      = {'offset':      pagination.start || $scope.stItemsOffset,
                                             'limit':       pagination.number || $scope.stItemsLimit,
                                             'sort_by':     table_state.sort.predicate,
                                             'filter':      $scope.stfilter,
                                             'sort_order':  (table_state.sort.reverse === false ? 'desc' : 'asc')};

                         if (typeof(me[fdRoute.action]) === 'undefined')
                             action = 'index';
                         else
                             action = fdRoute.action;

                         me[action]($injector, options).then(
                           function (data)
                           {
                             var path         = fdRoute.module + '/' + action;

                             $scope.is_admin  = data.is_admin;
                             ctrl.displayed   = data.results;

                             pagination
                               .numberOfPages = Math.ceil(data.total / options['limit']);

                             if (is_refresh !== true
                                 && typeof(fd_refresh_routes[path]) !== 'undefined')
                             {
                                is_refresh = true;
                                $timeout(function ()
                                         {
                                           ctrl.callServer(ctrl.table_state);
                                         },
                                         fd_refresh_routes[path]);
                             }

                             if (typeof(sgp_index_vars) === 'undefined')
                               return;

                             for (var varname in sgp_index_vars)
                             {
                               if (typeof(data[varname]) !== 'undefined')
                                  $scope[varname] = data[varname];
                             }
                           });
                       };

                       return this;
                     }

     this._show    = function ($scope, $injector)
                     {
                       var $http      = $injector.get('$http');
                       var $location  = $injector.get('$location');
                       var fdRoute    = $injector.get('fdRoute');
                       var deferred   = $injector.get('$q').defer();

                       $http.get('/api/' + fdRoute.module + '/show/' + fdRoute.id)
                            .success(
                              function (data)
                              {
                                deferred.resolve({'data': data});
                              })
                            .error(
                              function (data, xstatus)
                              {
                                deferred.reject();
                              });

                       return deferred.promise;
                     }

    this.show      = function ($scope, $injector, id)
                     {
                       $scope.fdBtnStatusClass      = fdBtnStatusClass;
                       $scope.fdIconStatusClass     = fdIconStatusClass;
                       $scope.fdActionStatusClass   = fdActionStatusClass;
                       $scope.fdSyncStatusClass    = fdSyncStatusClass;

                       var fdRoute  = $injector.get('fdRoute');
                       fdRoute.id   = id;

                       fd_api_resource._show($scope, $injector)
                                      .then(
                         function (result)
                         {
                           $scope.data = result['data'];

                           var modalInstance = $injector.get('$modal').open(
                            {
                              templateUrl: 'partials/' + fdRoute.module + '/show.html',
                              controller:  'fd-ctrl-module-show',
                              size:        'lg',
                              resolve:     {'data': function ()
                                                    {
                                                      return $scope.data;
                                                    }}
                            });
                         });
                     }

    this.index     = function ($injector, options)
                     {
                       var $http    = $injector.get('$http');
                       var fdRoute  = $injector.get('fdRoute');
                       var deferred = $injector.get('$q').defer();

                       $http.get('/api/' + fdRoute.module + '/index',
                                 {'params': options})
                            .success(
                              function (data)
                              {
                                deferred.resolve(data);
                              });

                       return deferred.promise;
                     }

    this.export   = function ($injector, options)
                    {
                      var $http    = $injector.get('$http');
                      var fdRoute  = $injector.get('fdRoute');
                      var deferred = $injector.get('$q').defer();

                      $http.get('/api/' + fdRoute.module + '/export',
                                {'params': options})
                           .success(
                             function (data)
                             {
                               deferred.resolve({
                                 is_admin: data['is_admin'],
                                 results: data['results'],
                                 total:   data['total']
                               });
                             });

                      return deferred.promise;
                    }

    this.download = function ($scope, $injector, path, data)
                    {
                      var $http      = $injector.get('$http');
                      var $location  = $injector.get('$location');
                      var fdRoute    = $injector.get('fdRoute');

                      $http.post('/api/filestore/download' + path,
                                 data,
                                 {'responseType': 'blob'})
                           .success(
                             function (data, status, headers)
                             {
                               headers = headers();

                               var filename = headers['x-filename'];
                               var contentType = headers['content-type'];

                               var link_element = document.createElement('a');
                               try
                               {
                                 var blob = data;
                                 blob.type = contentType;
                                 var url = (window.URL || window.webkitURL).createObjectURL(blob);

                                 link_element.setAttribute('href', url);
                                 link_element.setAttribute('download', filename);

                                 var click_event = new MouseEvent('click', {
                                     'view': window,
                                     'bubbles': true,
                                     'cancelable': false
                                 });
                                 link_element.dispatchEvent(click_event);
                               } catch (ex) {
                                   console.log(ex);
                               }
                             })
                           .error(
                             function (data, xstatus)
                             {
                               $scope.notify_code    = data.code || xstatus;
                               $scope.notify_message = data.message || 'Unknown Error';
                               angular.element('#fd-notify-error').removeClass('hide');
                             });
                    }

    this.unlink    = function ($scope, $injector, path, data)
                     {
                       var $http    = $injector.get('$http');
                       var fdRoute  = $injector.get('fdRoute');
                       var deferred = $injector.get('$q').defer();

                       $http.post('/api/filestore/unlink' + path,
                                  data)
                            .success(
                              function (data)
                              {
                                deferred.resolve();
                              })
                            .error(
                              function (data, xstatus)
                              {
                                deferred.reject();
                              });

                       return deferred.promise;
                     }

    this.deleted   = function ($injector, options)
                     {
                       var $http    = $injector.get('$http');
                       var fdRoute  = $injector.get('fdRoute');
                       var deferred = $injector.get('$q').defer();

                       $http.get('/api/' + fdRoute.module + '/deleted',
                                 {'params': options})
                            .success(
                              function (data)
                              {
                                deferred.resolve({
                                  is_admin: data['is_admin'],
                                  results: data['results'],
                                  total:   data['total']
                                });
                              });

                       return deferred.promise;
                     }

     this.get      = function ($scope, $injector)
                     {
                       var $http      = $injector.get('$http');
                       var $location  = $injector.get('$location');
                       var fdRoute    = $injector.get('fdRoute');
                       var deferred   = $injector.get('$q').defer();

                       $http.get('/api/' + fdRoute.module + '/get/' + fdRoute.id)
                            .success(
                              function (data)
                              {
                                deferred.resolve({'data': data});
                              })
                            .error(
                              function (data, xstatus)
                              {
                                $scope.notify_code    = data.code || xstatus;
                                $scope.notify_message = data.message || 'Unknown Error';
                                angular.element('#fd-notify-error').removeClass('hide');

                                deferred.reject();
                              });

                       return deferred.promise;
                     }

     this.create   = function ($scope, $injector, data)
                     {
                       var $http      = $injector.get('$http');
                       var $location  = $injector.get('$location');
                       var fdRoute    = $injector.get('fdRoute');

                       switch (fdRoute.module)
                       {
                         case 'vpn_user':
                           var servers = data['servers'];

                           if (typeof(data.servers.lists.selected) !== 'undefined')
                           {
                             data.servers_selected = [];
                             for (var i in data.servers.lists.selected)
                               data.servers_selected.push(data.servers.lists.selected[i]['id']);
                           }

                           delete data['servers'];
                           break;
                       }

                       if ($scope.submitted === true)
                       {
                           $location.path(fdRoute.module + '/index');
                           return;
                       }

                       $scope.submitted = true;

                       $http.post('/api/' + fdRoute.module + '/create',
                                  data)
                            .success(
                              function (data)
                              {
                                $location.path(fdRoute.module + '/index');
                              })
                            .error(
                              function (data, xstatus)
                              {
                                $scope.submitted      = false;
                                $scope.notify_code    = data.code || xstatus;
                                $scope.notify_message = data.message || 'Unknown Error';
                                angular.element('#fd-notify-error').removeClass('hide');
                              });
                     }

     this.update   = function ($scope, $injector, data)
                     {
                       var $http        = $injector.get('$http');
                       var $location    = $injector.get('$location');
                       var fdRoute      = $injector.get('fdRoute');

                       switch (fdRoute.module)
                       {
                         case 'vpn_user':
                           var servers = data['servers'];

                           if (typeof(data.servers.lists.selected) !== 'undefined')
                           {
                             data.servers_selected = [];
                             for (var i in data.servers.lists.selected)
                               data.servers_selected.push(data.servers.lists.selected[i]['id']);
                           }

                           delete data['servers'];
                           break;
                       }

                       if ($scope.submitted === true)
                       {
                           $location.path(fdRoute.module + '/index');
                           return;
                       }

                       $scope.submitted = true;

                       if (typeof(fd_del_vars[fdRoute.module]) !== 'undefined')
                       {
                         for (var i in fd_del_vars[fdRoute.module])
                         {
                           if (typeof(data[fd_del_vars[fdRoute.module][i]]) !== 'undefined')
                             delete data[fd_del_vars[fdRoute.module][i]];
                         }
                       }

                       $http.post('/api/' + fdRoute.module + '/update/' + fdRoute.id,
                                  data)
                            .success(
                              function (data)
                              {
                                $location.path(fdRoute.module + '/index');
                              })
                            .error(
                              function (data, xstatus)
                              {
                                $scope.submitted      = false;
                                $scope.notify_code    = data.code || xstatus;
                                $scope.notify_code    = data.code || xstatus;
                                $scope.notify_message = data.message || 'Unknown Error';
                                angular.element('#fd-notify-error').removeClass('hide');
                              });
                     }

     this._update_status = function ($scope, $injector, key_id, key_status)
                           {
                             var $http        = $injector.get('$http');
                             var $location    = $injector.get('$location');
                             var fdRoute      = $injector.get('fdRoute');
                             var deferred     = $injector.get('$q').defer();

                             $http.patch('/api/' + fdRoute.module + '/' + fdRoute.action + '/' + fdRoute.id)
                                  .success(
                                    function (data)
                                    {
                                      deferred.resolve({
                                        'id':     data[key_id],
                                        'status': data[key_status],
                                      });
                                    })
                                  .error(
                                    function (data, xstatus)
                                    {
                                      $scope.notify_code    = data.code || xstatus;
                                      $scope.notify_message = data.message || 'Unknown Error';
                                      angular.element('#fd-notify-error').removeClass('hide');

                                      deferred.reject();
                                    });

                             return deferred.promise;
                           }

     this.search   = function ($scope, $injector, module, data)
                     {
                       var $http      = $injector.get('$http');
                       var $location  = $injector.get('$location');
                       var deferred   = $injector.get('$q').defer();

                       $http.post('/api/' + module + '/search',
                                  {'keywords': data})
                            .success(
                              function (data)
                              {
                                $scope.search_items = data;
                              })
                            .error(
                              function (data, xstatus)
                              {
                                $scope.notify_code    = data.code || xstatus;
                                $scope.notify_message = data.message || 'Unknown Error';
                                angular.element('#fd-notify-error').removeClass('hide');

                                deferred.reject();
                              });

                       return deferred.promise;
                     }

     this.files    = function ($scope, $injector, data)
                     {
                       var $http      = $injector.get('$http');
                       var $location  = $injector.get('$location');
                       var deferred   = $injector.get('$q').defer();

                       $http.post('/api/filestore/index',
                                  data)
                            .success(
                              function (data)
                              {
                                deferred.resolve(data);
                              })
                            .error(
                              function (data, xstatus)
                              {
                                $scope.notify_code    = data.code || xstatus;
                                $scope.notify_message = data.message || 'Unknown Error';
                                angular.element('#fd-notify-error').removeClass('hide');

                                deferred.reject();
                              });

                       return deferred.promise;
                     }

    return {
      create:   me.create,
      disable:  me._update_status,
      enable:   me._update_status,
      remove:   me._update_status,
      update:   me.update,
      get:      me.get,
      index:    me.index,
      'export': me.export,
      download: me.download,
      unlink:   me.unlink,
      deleted:  me.deleted,
      show:     me.show,
      _show:    me._show,
      search:   me.search,
      files:    me.files,
      st_table: me.st_table,
    };
  }

  fd_app.factory('fdApiResource',
                 ['$injector', fdApiResource]);

  var fd_api_resource  = fdApiResource();

  function fdControllers()
  {
    return {
      'fd-ctrl-navbar':
        function ($scope, $location)
        {
          $scope.isActive = function (route)
          {
            return $location.path().indexOf(route) === 0;
          }
        },
      'fd-ctrl-module-index':     fd_api_resource.st_table,
      'fd-ctrl-module-export':    fd_api_resource.st_table,
      'fd-ctrl-module-deleted':   fd_api_resource.st_table,
      'fd-ctrl-module-view':      ['$scope', '$injector', '$routeParams',
        function ($scope, $injector, $routeParams)
        {
          $scope.fdBtnStatusClass     = fdBtnStatusClass;
          $scope.fdIconStatusClass    = fdIconStatusClass;
          $scope.fdSyncStatusClass    = fdSyncStatusClass;
          $scope.data                 = {};

          fd_api_resource.get($scope, $injector)
                         .then(function (data)
                               {
                                 $scope.data = data['data'];
                               });

          $scope.downloader            = function (data)
                                         {
                                           fd_api_resource.download($scope, $injector, '', data);
                                         }

        }],
      'fd-ctrl-module-show':      ['$scope', '$modalInstance', '$injector', '$routeParams', 'data',
        function ($scope, $modalInstance, $injector, $routeParams, data)
        {
          $scope.fdBtnStatusClass     = fdBtnStatusClass;
          $scope.fdIconStatusClass    = fdIconStatusClass;
          $scope.fdSyncStatusClass    = fdSyncStatusClass;

          $scope.downloader            = function (data)
                                         {
                                           fd_api_resource.download($scope, $injector, '', data);
                                         }

          $scope.data                  = data;
          $scope.ok                    = $modalInstance.close;
        }],
      'fd-ctrl-module-form':      ['$scope', '$injector', '$routeParams', 'uuid', 'FileUploader',
        function ($scope, $injector, $routeParams, uuid, FileUploader)
        {
          var action_name     = $routeParams.action;
          var nb_added_elt    = {};

          $scope.files        = {};
          $scope.submitted    = false;
          $scope.data         = {};
          $scope[action_name] = function (data)
                                {
                                  fd_api_resource[action_name]($scope, $injector, data);
                                }

          $scope.downloader   = function (data)
                                {
                                  fd_api_resource.download($scope, $injector, '', data);
                                }

          $scope.uploader               = new FileUploader({url: '/api/filestore/upload'});
          $scope.uploader.onSuccessItem = function(fileItem, response, xstatus, headers)
                                          {
                                            if (xstatus !== 200)
                                              return;

                                            if (typeof($scope.data.files_add) == 'undefined')
                                              $scope.data.files_add = [];

                                            $scope.data.files_add.push(response.token);
                                          }

          $scope.unlinker     = function (token)
                                {
                                  if (typeof($scope.data.files_del) == 'undefined')
                                    $scope.data.files_del = [];

                                  $scope.data.files_del.push(token);

                                  angular.element('#file-' + token).addClass('hide');
                                }

          $scope.fdDateBeforeRender = fdDateBeforeRender;

          $scope.search_items    = [];
          $scope.search          = function (data, module)
                                   {
                                     if (module === undefined)
                                       module = $routeParams.module;

                                     fd_api_resource['search']($scope, $injector, module, data.search);
                                   }

          $scope.search_onselect = function (key, value)
                                   {
                                     $scope.data[key] = value['id'];
                                   }

          $scope.refresh_token   = function ()
                                   {
                                     return uuid.v4();
                                   }

          if ($routeParams.module === 'vpn_client')
            $scope.fdVpnClientLoadLastOctets = function (server_id, client_id)
                                            {
                                              fdVpnClientLoadLastOctets($scope, $injector, server_id, client_id);
                                            }

          if (typeof(sgp_files) !== 'undefined')
            fd_api_resource['files']($scope, $injector, sgp_files).
                            then(function (data)
                                 {
                                    $scope.files = data;
                                 });

          switch (action_name)
          {
            case 'create':
              if ($routeParams.module === 'vpn_user')
                fdVpnUserLoadServers($scope, $injector, 0);
                break;

              if (typeof(fd_data) === 'undefined')
                break;
              break;
            case 'update':
              $scope.show = function (id)
                            {
                              fd_api_resource.show($scope, $injector, id);
                            }

              fd_api_resource.get($scope, $injector)
                             .then(function (result)
                                   {
                                     $scope.data = result['data'];
                                   });

              if (typeof(fd_data) === 'undefined')
                break;
              break;
          }
        }],
    };
  }

  var fd_controllers  = fdControllers();

  fd_app.config(['$routeProvider', '$injector',
    function($routeProvider, $injector)
    {
      $routeProvider.
        when('/:module/create/:nid?',
             {
               controller:  function ($routeParams, $scope, $injector, fdRoute)
                            {
                              $routeParams.action = 'create';

                              fdRoute.module  = $routeParams.module;
                              fdRoute.action  = $routeParams.action;
                              fdRoute.id      = null;

                              return fd_controllers['fd-ctrl-module-form'];
                            },
               templateUrl: function (params)
                            {
                              ret = 'partials/' + params.module + '/create.html';

                              if (params.nid)
                                  ret += '?nid=' + parseInt(params.nid).toString();

                              return ret
                            },
             }).
        when('/:module/update/:id',
             {
               controller:  function ($routeParams, $scope, $injector, fdRoute)
                            {
                              $routeParams.action = 'update';

                              fdRoute.module  = $routeParams.module;
                              fdRoute.action  = $routeParams.action;
                              fdRoute.id      = $routeParams.id;

                              return fd_controllers['fd-ctrl-module-form'];
                            },
               templateUrl: function (params)
                            {
                              return 'partials/' + params.module
                                     + '/update.html?id='
                                     + parseInt(params.id).toString();
                            },
             }).
        when('/:module/view/:id',
             {
               controller:  function ($routeParams, $scope, $injector, fdRoute)
                            {
                              fdRoute.module  = $routeParams.module;
                              fdRoute.action  = $routeParams.action;
                              fdRoute.id      = $routeParams.id;

                              return fd_controllers['fd-ctrl-module-view'];
                            },
               templateUrl: function (params)
                            {
                              return 'partials/' + params.module + '/view.html';
                            },
             }).
        when('/:module/:action/:id',
             {
               controller:  function ($routeParams, $scope, $injector, fdRoute)
                            {
                              fdRoute.module  = $routeParams.module;
                              fdRoute.action  = $routeParams.action;
                              fdRoute.id      = $routeParams.id;

                              return fd_controllers['fd-ctrl-module-' + fdRoute.action]($scope, $injector);
                            },
               templateUrl: function (params)
                            {
                              return 'partials/' + params.module + '/index.html';
                            },
             }).
        when('/:module/:action',
             {
               controller:  function ($routeParams, $scope, $injector, fdRoute)
                            {
                              fdRoute.module  = $routeParams.module;
                              fdRoute.action  = $routeParams.action;
                              fdRoute.id      = null;

                              return fd_controllers['fd-ctrl-module-' + fdRoute.action];
                            },
               templateUrl: function (params)
                            {
                              return 'partials/' + params.module + '/' + params.action + '.html';
                            },
             }).
        otherwise({redirectTo:  '/vpn_client/index'});
  }]).controller(fd_controllers);
 })();
